#include "DrawingContext.h"

#include "AbstractGeometricItem.h"
#include "AbstractPainter.h"
#include "OpenGlPainter.h"
#include "RasterPainter.h"
#include "DrawingSurface.h"
#include "Scene.h"
#include "Grid.h"

#include "MeshBuilder.h"

#include "TriMesh.h"

DrawingContext::DrawingContext(DrawingSurface* surface, DrawingMode requestedDrawingMode)
    : mSurface(surface),
      mDrawingMode(requestedDrawingMode),
      mScene(std::make_unique<Scene>())
{
    if (mDrawingMode == DrawingMode::GRAPH)
    {
        mPainter = std::make_unique<OpenGlPainter>();
    }
    else
    {
        mPainter = std::make_unique<RasterPainter>();
    }
}

std::unique_ptr<DrawingContext> DrawingContext::Create(DrawingSurface* surface, DrawingMode requestedDrawingMode)
{
    return std::make_unique<DrawingContext>(surface, requestedDrawingMode);
}

void DrawingContext::updateMesh()
{

}

Scene* DrawingContext::getScene() const
{
    return mScene.get();
}

DrawingSurface* DrawingContext::getSurface() const
{
    return mSurface;
}

void DrawingContext::paint()
{

}
