#pragma once

#include <memory>
#include <string>

class TextNode;

class DrawingSurface;
using DrawingSurfacePtr = std::unique_ptr<DrawingSurface>;
class DrawingContext;
using DrawingContextPtr = std::unique_ptr<DrawingContext>;

class DrawingManager
{
public:
    DrawingManager();
    static std::unique_ptr<DrawingManager> Create();
    void InitalizeSurface(unsigned width, unsigned height);
    void InitializeContext();
    void AddText(TextNode* text);
    void RenderToFile(const std::string& path);

private:
    DrawingSurfacePtr mDrawingSurface {nullptr};
    DrawingContextPtr mDrawingContext {nullptr};
};

using DrawingManagerPtr = std::unique_ptr<DrawingManager>;
