#pragma once

#include <memory>

template<typename T>
class Image;

class DrawingSurface
{
public:
    DrawingSurface() = default;
    virtual ~DrawingSurface() = default;

    static std::unique_ptr<DrawingSurface> Create();

    void setSize(unsigned width, unsigned height);

    unsigned getWidth() const;

    unsigned getHeight() const;

    Image<unsigned char>* getImage();

protected:
    unsigned mWidth = 0;
    unsigned mHeight = 0;
    std::unique_ptr<Image<unsigned char> > mBackingImage;
};
