#pragma once

#include <vector>
#include <memory>

class Node;
class Edge;
class TriFace;

using NodePtr = std::unique_ptr<Node>;
using EdgePtr = std::unique_ptr<Edge>;
using TriFacePtr = std::unique_ptr<TriFace>;

using VecNodes = std::vector<NodePtr>;
using VecEdges = std::vector<EdgePtr>;
using VecFaces = std::vector<TriFacePtr>;

class TriMesh
{
public:
    TriMesh() = default;

    ~TriMesh();

    void populate(VecNodes& nodes, VecEdges& edges, VecFaces& faces);

private:
    VecNodes mNodes;
    VecEdges mEdges;
    VecFaces mFaces;
};
