#pragma once

#include "AbstractMesh.h"
#include "Image.h"
#include "DiscretePoint.h"
#include <memory>

class AbstractVisualNode
{
public:
    AbstractVisualNode(const DiscretePoint& location)
        : mLocation(location)
    {

    }

    AbstractMesh* getMesh() const
    {
        return mMesh.get();
    }

    Image<unsigned char>* getImage() const
    {
        return mImage.get();
    }

    const DiscretePoint& getLocation() const
    {
        return mLocation;
    }

private:
    DiscretePoint mLocation;
    std::unique_ptr<AbstractMesh> mMesh;
    std::unique_ptr<Image<unsigned char> > mImage;
};
