#include "GeometryNode.h"

GeometryNode::GeometryNode(const DiscretePoint& location)
    :   AbstractVisualNode(location),
        mFillColor(Color(255, 255, 255)),
        mStrokeColor(Color(0, 0, 0)),
        mStrokeThickness(1),
        mType(Type::Path)
{

}

const Color& GeometryNode::getFillColor() const
{
    return mFillColor;
}

const Color& GeometryNode::getStrokeColor() const
{
    return mStrokeColor;
}

unsigned GeometryNode::getStrokeThickness() const
{
    return mStrokeThickness;
}

void GeometryNode::setFillColor(const Color& color)
{
    mFillColor = color;
}

void GeometryNode::setStrokeColor(const Color&  color)
{
    mStrokeColor = std::move(color);
}

void GeometryNode::setStrokeThickness(unsigned thickness)
{
    mStrokeThickness = thickness;
}
