#pragma once
#include <memory>

class GeometryNode;
class TextNode;

class VisualLayer
{
public:

    VisualLayer();

    static std::unique_ptr<VisualLayer> Create();

    GeometryNode* getShape() const;
    TextNode* getText() const;
    bool hasShape() const;
    bool hasText() const;
    void setShape(std::unique_ptr<GeometryNode> shape);
    void setText(std::unique_ptr<TextNode> text);

private:
    std::unique_ptr<GeometryNode> mShape;
    std::unique_ptr<TextNode> mText;
};
using VisualLayerUPtr = std::unique_ptr<VisualLayer>;
